%FRICTIONPLOT.M
%This script opens and reads the equivalent friction coefficient used in
%the MATERIAL card in SIMLA, and plots them. 

clear all
close all
clc

format long

%ORIGINAL CASE

%Open the files:

disp = fopen('fric_orig.dat');

% The text files are read:

m = 3;       %Number of input lines/time steps in the text file
n = 2;       %Number of coloumns

dispinfo = (fscanf(disp, '%f %f', [n,m]))';

%Assigning to new matrices:

x = dispinfo(:,1);
y = dispinfo(:,2);

x_neg = -x;
y_neg = -y;


%Plotting:

figure;
hold on
h=gca;
set(h,'fontsize',22)
plot(x,y,'r','linewidth',2);
plot(x_neg,y_neg,'r','linewidth',2);
title('Coulomb friction for the original case');
xlabel('Displacement [m]');
ylabel('Equivalent Friction Factor [-]');
axis([-1010 1005 -0.35 0.35])
axis square


%0.1 CASE

%Open the files:

disp = fopen('fric_0_10.dat');

% The text files are read:

m = 3;       %Number of input lines/time steps in the text file
n = 2;       %Number of coloumns

dispinfo = (fscanf(disp, '%f %f', [n,m]))';

%Assigning to new matrices:

x = dispinfo(:,1);
y = dispinfo(:,2);

x_neg = -x;
y_neg = -y;


%Plotting:

figure;
hold on
h=gca;
set(h,'fontsize',30)
plot(x,y,'r','linewidth',2);
plot(x_neg,y_neg,'r','linewidth',2);
title('Coulomb friction for the 0.10 case');
xlabel('Displacement [m]');
ylabel('Equivalent Friction Factor [-]');
axis([-1010 1005 -0.11 0.11])
axis square


%1.1 CASE

%Open the files:

disp = fopen('fric_1_10.dat');

% The text files are read:

m = 3;       %Number of input lines/time steps in the text file
n = 2;       %Number of coloumns

dispinfo = (fscanf(disp, '%f %f', [n,m]))';

%Assigning to new matrices:

x = dispinfo(:,1);
y = dispinfo(:,2);

x_neg = -x;
y_neg = -y;


%Plotting:

figure;
hold on
h=gca;
set(h,'fontsize',30)
plot(x,y,'r','linewidth',2);
plot(x_neg,y_neg,'r','linewidth',2);
title('Coulomb friction for the 1.10 case');
xlabel('Displacement [m]');
ylabel('Equivalent Friction Factor [-]');
axis([-1010 1005 -1.2 1.2])
axis square


%2.1 CASE

%Open the files:

disp = fopen('fric_2_10.dat');

% The text files are read:

m = 3;       %Number of input lines/time steps in the text file
n = 2;       %Number of coloumns

dispinfo = (fscanf(disp, '%f %f', [n,m]))';

%Assigning to new matrices:

x = dispinfo(:,1);
y = dispinfo(:,2);

x_neg = -x;
y_neg = -y;


%Plotting:

figure;
hold on
h=gca;
set(h,'fontsize',30)
plot(x,y,'r','linewidth',2);
plot(x_neg,y_neg,'r','linewidth',2);
title('Coulomb friction for the 2.10 case');
xlabel('Displacement [m]');
ylabel('Equivalent Friction Factor [-]');
axis([-1010 1005 -2.4 2.4])
axis square

