%SNAKE.M
%Opens and reads the .dat files, plot the results and calculate the overall
%walk and walk per cycle for each case.


clear all
close all
fclose('all')
clc

N = 8;             %Number of files

m = 4851;           %Number of input lines/time steps in the text file
n = 2;              %Number of coloumns

count = 50;         %Counter
count2 = 50;        %Counter no 2

w_tot = zeros(N,1);

%Print to screen:
fprintf('\n')
fprintf('\nThe overall walk after 12 cycles')
fprintf('\nfor the middle node in axial direction:')

cc2=hsv(N);
figure;
hold on
h=gca;
set(h,'fontsize',26)

for s = 1:N
        
    if count <= 200
    
        %Opening and the files:
    
        disp = fopen(['snake_middle_250_' num2str(count) '.dat']);
        
    else

        disp = fopen(['snake_middle_400_' num2str(count2) '.dat']);
        
        count2 = count2 + 50;
        
    end
    
    %Reading the files:
    
    dispinfo = (fscanf(disp, '%d %f', [n,m]))';
    
    timestep = dispinfo(:,1);
    displ = dispinfo(:,2);
    
    %Calcultaing overall walk:
    
    w_tot(s) = displ(m);
    
    if count <= 200
        
        fprintf('\nfor the case r = 250 [m] and c = d [m] is %.4f [m]',  w_tot(s))
        
        %count(s),
        
    else
        
        %count2(s-1),
        
        fprintf('\nfor the case r = 400 [m] and c = d [m] is %.4f [m]',  w_tot(s))
        
    end
    
    count = count + 50;
    
    %Plot:
    
    plot(timestep,displ,'color',cc2(s,:),'linewidth',2);
    
end

line([426 426],[-5.4 2.9],'linewidth',1)
line([826 826],[-5.4 2.9],'linewidth',1)
line([1226 1226],[-5.4 2.9],'linewidth',1)
line([1626 1626],[-5.4 2.9],'linewidth',1)
line([2026 2026],[-5.4 2.9],'linewidth',1)
line([2426 2426],[-5.4 2.9],'linewidth',1)
line([2826 2826],[-5.4 2.9],'linewidth',1)
line([3226 3226],[-5.4 2.9],'linewidth',1)
line([3626 3626],[-5.4 2.9],'linewidth',1)
line([4026 4026],[-5.4 2.9],'linewidth',1)
line([4426 4426],[-5.4 2.9],'linewidth',1)
line([4826 4826],[-5.4 2.9],'linewidth',1)
title('Axial displacement at the middle node with varying radius and curvelength');
xlabel('Time step [s]');
ylabel('Displacement [m]');
%legend('250\_50','250\_100','250\_150','250\_200','400\_50','400\_100','400\_150','400\_200')
legend('r = 250 [m], c = 50 [m]','r = 250 [m], c = 100 [m]','r = 250 [m], c = 150 [m]','r = 250 [m], c = 200 [m]','r = 400 [m], c = 50 [m]','r = 400 [m], c = 100 [m]','r = 400 [m], c = 150 [m]','r = 400 [m], c = 200 [m]')
axis([0 5000 -5.4 2.0])
axis square


fprintf('\n')


%Walk per cycle:


k = 12;         %Number of cycles
t = 400;        %One cycle is t time steps
l = k-2;        %The number of cycles "walk per cycle" is based on

c_temp = zeros(k,1);    %Temporary variable for c
c = zeros(k,1);         %Matrix with time steps at a given point in each cycle
c_temp(1) = 426;

w_c = zeros(N,1);

count = 50;         %Counter
count2 = 50;        %Counter no 2

for u = 1:N
    
    %Opening and reading the text files:
    
    if count <= 200
    
        %Opening and the files:
    
        disp = fopen(['snake_middle_250_' num2str(count) '.dat']);
        
    else

        disp = fopen(['snake_middle_400_' num2str(count2) '.dat']);
        
        count2 = count2 + 50;
        
    end
    
    %Reading the files:
    
    dispinfo = (fscanf(disp, '%d %f', [n,m]))';
    
    %Assigning to new matrices:

    time_step = dispinfo(:,1);
    displ = dispinfo(:,2);
    
    w = zeros(k,1);
    
    for i = 1:k
    
    c_temp(i+1) = c_temp(i) + t;
    c(i) = c_temp(i);
    
    w(i) = displ(c(i));
             
    end
    
    d_w = zeros(k,1);
    d_w(1) = w(1);
    
    for j = 2:k
    
    d_w(j) = w(j) - w(j-1);
    
    end
    

    if u == N/2
        
        w_4 = w(k); 
        d_w(N/2) = w_tot(N/2) - w_4;
        
    elseif u == N
        
        w_8 = w(k);
        d_w(N) = w_tot(N) - w_8;
        
    end
    
        
    %Walk per cycle:
    
    w_c_mean = zeros(l,1);
    
    for o = 1:l
    
    w_c_mean(o,1) = d_w(o+2,1);
    
    end
        
    w_c(u) = mean(w_c_mean);
    
    count = count + 50;
      
    
end


%Curve Lengths:

N_c = N/2;

cl = zeros(N_c,1);
cl(1,1) = 50;

for q = 2:length(cl)

    cl(q) = cl(q-1) + 50;
    
end



%For r = 250[m]:

w_c_250 = zeros(N_c,1);

for p = 1:N_c
    
    w_c_250(p) = w_c(p);
    
end


%Plotting curve length against walk per cycle, and fitting a curve to the points:

figure;
hold on
h=gca;
set(h,'fontsize',26)
%plot(a, w_c, 'X');
plot(cl, w_c_250, '--bs','LineWidth',2,'MarkerEdgeColor','b','MarkerFaceColor','b','MarkerSize',10)
title('Curve length vs. Walk per Cycle');
xlabel('Curve length [m]');
ylabel('Walk per Cycle [m]');
%axis([0.35 0.65 -0.006 0.0125])
grid on
axis square

%Print to screen:

fprintf('\nThe walk per cycle for the r = 250 [m] case')

for v = 1:N_c

fprintf('\n is %.4f [m] for a curve length of %d [m]', w_c_250(v), cl(v))

end

fprintf('\n')


%For r = 400[m]:

w_c_400 = zeros(N_c,1);

for p = 1:N_c
    
    w_c_400(p) = w_c(p+4);
    
end


%Plotting curve length against walk per cycle, and fitting a curve to the points:

figure;
hold on
h=gca;
set(h,'fontsize',26)
%plot(a, w_c, 'X');
plot(cl, w_c_400, '--bs','LineWidth',2,'MarkerEdgeColor','b','MarkerFaceColor','b','MarkerSize',10)
title('Curve length vs. Walk per Cycle');
xlabel('Curve length [m]');
ylabel('Walk per Cycle [m]');
%axis([0.35 0.65 -0.006 0.0125])
grid on
axis square

%Print to screen:

fprintf('\nThe walk per cycle for the r = 400 [m] case')

for v = 1:N_c

fprintf('\n is %.4f [m] for a curve length of %d [m]', w_c_400(v), cl(v))

end

fprintf('\n \n')


%Plotting curve length against walk per cycle, and fitting a curve to the points:

figure;
hold on
h=gca;
set(h,'fontsize',26)
%plot(a, w_c, 'X');
plot(cl, w_c_250, '--gs','LineWidth',2,'MarkerEdgeColor','g','MarkerFaceColor','g','MarkerSize',10)
plot(cl, w_c_400, '--bs','LineWidth',2,'MarkerEdgeColor','b','MarkerFaceColor','b','MarkerSize',10)
title('Curve length vs. Walk per Cycle');
xlabel('Curve length [m]');
ylabel('Walk per Cycle [m]');
legend('Radius = 250 [m]','Radius = 400 [m]')
axis([45 205 0 0.25])
grid on
axis square

