# Running script for general plotting tool
# IKM Ocean Design AS
# 2011

### Start - DO NOT MODIFY
from IKM_PlottingTool import *
### End - DO NOT MODIFY
from pylab import *

# Log file initializaton
deleteFile('logfile.out')
g = startFileLogging('logfile.out')

# Define which time steps to read
STEPS = [1,6,51,426,451,826,851,1226,1251,1626,1651,2026,2051,2426,2451,2826,2851,3226,3251,3626,3651,4026,4051,4426,4451,4826,4851]
NameSteps = ['1','6','51','426','451','826','851','1226','1251','1626','1651','2026','2051','2426','2451','2826','2851','3226','3251','3626','3651','4026','4051','4426','4451','4826','4851']

# Read in result files
axF40       = readSteps('axialforce.mpf', STEPS,'time',g)
MomY40      = readSteps('ymoment.mpf', STEPS,'time',g)
MomZ40      = readSteps('zmoment.mpf', STEPS,'time',g)
horProf40   = readSteps('X-Y.mpf', STEPS, 'time', g)
NodeYDisp40 = readSteps('Nodisp-y.mpf', STEPS, 'time', g)
NodeXDisp40 = readSteps('Nodisp-y.mpf', STEPS, 'time', g)

# Compute resultant moment
resMom40 = resY(MomZ40, MomY40,'moment',g)

#resMom = combineDatasets([resMom40, resMom60],'N/A', 'Resultant moment [Nm]'    , ['40 Deg', '60 Deg'], g)
axF    = combineDatasets([axF40,    axF40],    'N/A', 'Effective Axial Friction Force [N]', ['40 Deg', '60 Deg'], g)

# Compute axial and lateral displacement in global coordinates
ADisp40 = AxDisp(horProf40, NodeYDisp40, NodeXDisp40, 'Axial Displacement [m]')
LDisp40 = LatDisp(horProf40,NodeYDisp40, NodeXDisp40, 'Lateral Displacement [m]')

#writeDataset(LDisp40[-1], 'LDispSimlaStretch1.csv', 'data',g=None)
for i in range(len(STEPS)):
    writeDataset(LDisp40[i], 'LDispSimla_%s.csv'%STEPS[i], 'data',g=None)
    writeDataset(resMom40[i], 'resMomSimla_%s.csv'%STEPS[i], 'data',g=None)


for i in range(len(STEPS)):
    ADisp40[i].set_legends(['X', NameSteps[i]])
    LDisp40[i].set_legends(['X', NameSteps[i]])
    axF40[i].set_legends(['X', NameSteps[i]])
    resMom40[i].set_legends(['X', NameSteps[i]])


IKMPlot([axF40],[0,3000],'Axial_force_all.png',g)


# Close logfile
stopFileLogging(g)
